
/*! \file
 *     contributors.h
 *  \brief
 *     List of contributors and copyright information.
 *
 *  \par Copyright statements
    \verbatim
   H.264 JM coder/decoder

   Copyright (C) 2000 by
      Telenor Satellite Services, Norway
      Ericsson Radio Systems, Sweden
      TELES AG, Germany
      Nokia Inc., USA
      Nokia Corporation, Finland
      Siemens AG, Germany
      Heinrich-Hertz-Institute for Communication Technology GmbH, Germany
      University of Hannover, Institut of Communication Theory and Signal Processing,Germany
      TICSP, Tampere University of Technology, Finland
      Munich University of Technology, Institute for Communications Engineering, Germany
      Videolocus, Canada
      Motorola Inc., USA
      Microsoft Corp., USA
      Apple Computer, Inc.
      RealNetworks, Inc., USA
      Thomson, Inc., USA
  \endverbatim
  \par Full Contact Information
  \verbatim

      Lowell Winger                   <lwinger@videolocus.com><lwinger@uwaterloo.ca>
      Guy Ct                        <gcote@videolocus.com>
      Michael Gallant                 <mgallant@videolocus.com>
      VideoLocus Inc.
      97 Randall Dr.
      Waterloo, ON, Canada  N2V1C5

      Inge Lille-Langy               <inge.lille-langoy@telenor.com>
      Telenor Satellite Services
      P.O.Box 6914 St.Olavs plass
      N-0130 Oslo, Norway

      Rickard Sjoberg                 <rickard.sjoberg@era.ericsson.se>
      Ericsson Radio Systems
      KI/ERA/T/VV
      164 80 Stockholm, Sweden

      Stephan Wenger                  <stewe@cs.tu-berlin.de>
      TU Berlin / TELES AG
      Sekr. FR 6-3
      Franklinstr. 28-29
      D-10587 Berlin, Germany

      Jani Lainema                    <jani.lainema@nokia.com>
      Nokia Inc. / Nokia Research Center
      6000 Connection Drive
      Irving, TX 75039, USA

      Sebastian Purreiter             <sebastian.purreiter@mch.siemens.de>
      Siemens AG
      ICM MD MP RD MCH 83
      P.O.Box 80 17 07
      D-81617 Munich, Germany

      Thomas Wedi                     <wedi@tnt.uni-hannover.de>
      University of Hannover
      Institut of Communication Theory and Signal Processing
      Appelstr. 9a
      30167 Hannover, Germany

      Guido Heising                   <heising@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Gabi Blaettermann               <blaetter@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Detlev Marpe                    <marpe@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Ragip Kurceren                  <ragip.kurceren@nokia.com>
      Nokia Inc. / Nokia Research Center
      6000 Connection Drive
      Irving, TX 75039, USA

      Viktor Varsa                    <viktor.varsa@nokia.com>
      Nokia Inc. / Nokia Research Center
      6000 Connection Drive
      Irving, TX 75039, USA

      Ye-Kui Wang                     <wyk@ieee.org>
      Tampere University of Technology
      Tampere International Center for Signal Processing
      33720 Tampere, Finland

      Ari Hourunranta                 <ari.hourunranta@nokia.com>
      Nokia Corporation / Nokia Mobile Phones
      P.O. Box 88
      33721 Tampere, Finland

      Yann Le Maguet                  <yann.lemaguet@philips.com>
      Philips Research France

      Dong Tian                       <tian@cs.tut.fi>
      Tampere University of Technology
      Tampere International Center for Signal Processing
      33720 Tampere, Finland

      Miska M. Hannuksela             <miska.hannuksela@nokia.com>
      Nokia Corporation / Nokia Mobile Phones
      P.O. Box 88
      33721 Tampere, Finland

      Karsten Suehring                <suehring@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Heiko Schwarz                   <hschwarz@hhi.de>
      Heinrich-Hertz-Institute
      Einsteinufer 37
      10587 Berlin
      Germany

      Tobias Oelbaum                  <drehvial@gmx.net>
      Institute for Communications Engineering
      Munich University of Technology
      Germany

      Limin Wang                      <liwang@gi.com>
      Krit Panusopone                 <kpanusopone@gi.com>
      Rajeev Gandhi                   <rgandhi@gi.com>
      Yue Yu                          <yyu@gi.com>
      Motorola Inc.
      6450 Sequence Drive
      San Diego, CA 92121 USA

      Feng Wu                         <fengwu@microsoft.com>
      Xiaoyan Sun                     <sunxiaoyan@msrchina.research.microsoft.com>
      Microsoft Research Asia
      3/F, Beijing Sigma Center
      No.49, Zhichun Road, Hai Dian District,
      Beijing China 100080

      Yoshihiro Kikuchi               <yoshihiro.kikuchi@toshiba.co.jp>
      Takeshi Chujoh                  <takeshi.chujoh@toshiba.co.jp>
      Toshiba Corporation
      Research and Development Center
      Kawasaki 212-8582, Japan

      Shinya Kadono                   <kadono@drl.mei.co.jp>
      Matsushita Electric Industrial Co., Ltd.
      1006 Kadoma, Kadoma
      Osaka 663-8113, Japan

      Dzung Hoang                     <dthoang@yahoo.com>
      10533 Roy Butler Dr.
      Austin, TX 78717

      Eric Viscito                    <eric@ev-consulting.com>
      eV Consulting
      52 Tracy Ln
      Shelburne, VT 05482 USA

      Barry Haskell
      Apple Computer, Inc.            <bhaskell@apple.com>
      2 Infinite Loop
      Cupertino, California 95014

      Greg Conklin
      RealNetworks, Inc.              <gregc@real.com>
      2601 Elliott Ave
      Seattle, WA 98101

      Jill Boyce                      <jill.boyce@thomson.net>
      Cristina Gomila                 <cristina.gomila@thomson.net>
      Thomson
      2 Independence Way
      Princeton, NJ 08540

      Alexis Michael Tourapis         <alexismt@ieee.org><atour@dolby.com>
      Athanasios Leontaris            <aleon@dolby.com>
      Dolby Laboratories Inc.
      3601 West Alameda Ave.
      Burbank, CA 91505

      Saurav K Bandyopadhyay          <saurav@ieee.org>
      Purvin Pandit                   <Purvin.Pandit@thomson.net>
      Zhenyu Wu                       <Zhenyu.Wu@thomson.net>
      Thomson Inc.
      2 Independence Way
      Princeton, NJ 08540



  \endverbatim
*/

